import type { GetLink, RouteWithLink, RouteLink } from "./types";
import { ParamsValidation, QueryParamsValidation } from "validations";
export declare function getLinks<T extends {
    [x: string]: RouteWithLink;
}>(links: T): {
    [P in keyof T]: GetLink<T[P]>;
};
export declare function generateLink<Path extends string, Params extends {
    [x: string]: ParamsValidation<any>;
} = {}, Query extends {
    [x: string]: QueryParamsValidation<any>;
} = {}>(path?: Path, params?: Params, query?: Query): RouteLink<Path, Params, Query>;
