import React from "react";
import type { RouteProps } from "react-router";
import { ParamsValidation, QueryParamsValidation } from "../validations";
import type { RouteHOCProps, Params, RouteLink, QueryParams, RoutePath, GetPath } from "../types";
export declare function Route<Props>(WrappedComponent: React.FC<Props & RouteHOCProps>): React.FC<Props & RouteProps>;
export declare namespace Route {
    var params: ParamsValidation<never>;
    var query: QueryParamsValidation<never>;
}
export declare function Route<Path extends string>(path: Path): <Props>(WrappedComponent: React.FC<Props & RouteHOCProps<Path>>) => React.FC<Props & RouteProps> & {
    link: RouteLink<Path>;
};
export declare namespace Route {
    var params: ParamsValidation<never>;
    var query: QueryParamsValidation<never>;
}
export declare function Route<Validation extends {
    [x: string]: ParamsValidation<any> | QueryParamsValidation<any>;
}, Path extends RoutePath<Params<Validation>>>(validation: Validation, path: Path): <Props>(WrappedComponent: React.FC<Props & RouteHOCProps<GetPath<Path>, Params<Validation>, QueryParams<Validation>>>) => React.FC<Props & RouteProps> & {
    link: RouteLink<GetPath<Path>, Params<Validation>, QueryParams<Validation>>;
};
export declare namespace Route {
    var params: ParamsValidation<never>;
    var query: QueryParamsValidation<never>;
}
