import React, { FC } from "react";
import { RouteComponentProps } from "react-router";
import type { RouteProps } from "react-router";
import { ParamsValidation, QueryParamsValidation } from "../validations";
import type { RouteLink, QueryParams } from "../types";
export declare const isFunction: (value: any) => value is (...args: any[]) => any;
export declare const isComponent: (value: any) => value is React.FunctionComponent<{}>;
export declare function wrappedComponentFactory<Props extends RouteComponentProps>(WrappedComponent: FC<Props>): FC<Props & {
    queryValidation?: QueryParams<any>;
    link: RouteLink<string>;
}>;
export declare function routeComponentFactory<Props extends RouteComponentProps, Validation extends {
    [x: string]: ParamsValidation<any> | QueryParamsValidation<any>;
}>(wrappedComponent: FC<Props>, link: (...args: any[]) => string | undefined, validation?: Validation): FC<RouteProps> & {
    link?: (...args: any[]) => string | undefined;
};
