import { ExtractArray } from "../types";
export declare class ParamsValidation<T = never> {
    private _rules?;
    private regexes;
    constructor(_rules?: {
        string: boolean | RegExp | T | (string | number)[];
        number: boolean | RegExp | T | (string | number)[];
        enum: boolean | RegExp | T | (string | number)[];
        regex: boolean | RegExp | T | (string | number)[];
        optional: boolean | RegExp | T | (string | number)[];
    } | undefined);
    generateRules: (paramKey: string) => string | undefined;
    oneOf<Keys extends Array<number | string>>(...keys: Keys): ParamsValidation<T | ExtractArray<Keys>>;
    get string(): ParamsValidation<string | T>;
    regex(reg: RegExp): ParamsValidation<string | T>;
    get number(): ParamsValidation<number | T>;
    get optional(): ParamsValidation<T | undefined>;
}
