import type { ExtractArray, QueryParams } from "../types";
export declare const match: <T>(search: string, rules?: QueryParams<T> | undefined) => T;
export declare class QueryParamsValidation<T = never> {
    private _rules?;
    private initialRules;
    private validators;
    constructor(_rules?: {
        string?: boolean | RegExp | QueryParamsValidation<any> | (string | number)[] | undefined;
        number?: boolean | RegExp | QueryParamsValidation<any> | (string | number)[] | undefined;
        enum?: boolean | RegExp | QueryParamsValidation<any> | (string | number)[] | undefined;
        boolean?: boolean | RegExp | QueryParamsValidation<any> | (string | number)[] | undefined;
        array?: boolean | RegExp | QueryParamsValidation<any> | (string | number)[] | undefined;
        regex?: boolean | RegExp | QueryParamsValidation<any> | (string | number)[] | undefined;
    } | undefined);
    validate(value: any[]): T;
    array<K extends QueryParamsValidation<any>>(type: K): QueryParamsValidation<T | (K extends QueryParamsValidation<infer V> ? V : any)[] | undefined>;
    get number(): QueryParamsValidation<number | T | undefined>;
    get string(): QueryParamsValidation<string | T | undefined>;
    get boolean(): QueryParamsValidation<boolean | T | undefined>;
    regex(rule: RegExp): QueryParamsValidation<string | T | undefined>;
    oneOf<Keys extends Array<number | string>>(...keys: Keys): QueryParamsValidation<T | ExtractArray<Keys> | undefined>;
}
